<?php

/**
 * terceros actions.
 *
 * @package    controlComisiones
 * @subpackage terceros
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tercerosActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'TERCEROS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'TERCEROS_V' =>
        array(
            'num_doc' => 'num_doc',
            'nitocc' => 'nitocc',
            'tipter' => 'tipter',
            'razsoc' => 'razsoc',
            'ciudad' => 'ciudad',
            'telefo' => 'telefo',
            'telfax' => 'telfax',
            'direcc' => 'direcc',
            'estado' => 'estado',
            'email' => 'email',
            'sueldo' => 'sueldo',
            'cargo' => 'cargo',
            'codreg' => 'codreg',
            'id_tipo_traba_contra' => 'id_tipo_traba_contra',
            'nitocc,||, - ,||,razsoc' => 'completo',
            'descripcion' => 'descripcion_tipter',
            'tipter,||, - ,||,descripcion' => 'completo_tipter'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'nitocc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'TERCEROS_V' =>
        array(
            'num_doc,a' => array('!=' => array(-1)),
            'num_doc,b' => array('=' => array('num_doc')),
            'tipter' => array('=' => array('tipter')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'TERCEROS_V' =>
        array(
            'num_doc' => array('LIKEALL' => array('input', '%')),
            'razsoc' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas


    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'nitocc'; //identificador de la tabla
    protected $id_names = array('nitocc'); //llave primaria
    protected $field_names = array('tipter', 'razsoc', 'ciudad', 'telefo', 'telfax', 'direcc',
        'estado', 'email', 'sueldo', 'cargo', 'codreg', 'id_tipo_traba_contra'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'TERCEROS'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'nitocc'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        return $errors;
    }

}
